use std::error::Error as StdError;
use std::io::Error as IoError;
use std::net::AddrParseError;
use hyper::Error as HyperError;

use {RawResponse, StatusCode};


error_chain! {
    types {
        SusanooError, SusanooErrorKind, ResultExt, SusanooResult;
    }

    foreign_links {
        AddrParse(AddrParseError);
        Hyper(HyperError);
        StdIo(IoError);
    }
}


/// Error type thrown during handling
pub enum HandleError {
    Status(StatusCode),
    Internal(Box<StdError + Send + 'static>),
    Raw(RawResponse),
}
